//
// parser.cc for sls
//
// Made by Seblu
// Login   <seblu@epita.fr>
//
// Started on  Tue Jun  5 22:35:19 2007 Seblu
// Last update Thu Jun  7 02:31:13 2007 Seblu
//

#include <stdio.h>
#include "sls.hh"

#define BUF_LOGIN 12
#define BUF_CPASS 20
#define BUF_SPASS 20
#define BUF_LINE 255

Parser::Parser(const string filename, SLServer &server, bool verbose)
  : filename_(filename), server_(server), verbose_(verbose)
{
  ifstream fs;
  char buf[BUF_LINE];
  char login[BUF_LOGIN];
  char client_pass[BUF_CPASS];
  char server_pass[BUF_SPASS];
  int  privilege;
  int line = 0;

  fs.open(filename_.c_str());

  if (!fs.is_open())
    throw Error("Unable to open access file.", EXIT_FILE);

  while (!fs.eof()) {
    fs.getline(buf, BUF_LINE);
    ++line;
    if (*buf == '\0')
      continue;
    // hard coded max len value ! This sucks !
    if (sscanf(buf, "%12[^:]:%20[^:]:%20[^:]:%d",
	       login, server_pass, client_pass, &privilege) != 4) {
      Error *err = new Error("Unable to understand line ");
      *err << line << ".";
      throw *err;
    }

    server_.add_access(login, server_pass, client_pass, privilege);

    if (verbose_)
      std::cout << "Added user '" << login
		<< "' with privilege '" << privilege << "'"
		<< std::endl;
  }
  if (verbose_)
    std::cout << "Read " << line << " lines." << std::endl;

  fs.close();
}
